/*
 *	DBSC Mode for CodeMirror 2 by DBSC-Tools
 *	@author James Thorne (partydroid)
 *	@link 	http://github.com/partydroid/DBSC-Tools
 * 	@link 	http://dbsctools.org
 *	@version 02/Jan/2012
*/
CodeMirror.defineMode("dbsc", function(config) {
  var indentUnit = config.indentUnit;
  var curPunc;

  function wordRegexp(words) {
    return new RegExp("^(?:" + words.join("|") + ")$", "i");
  }
  var ops = wordRegexp(["str", "lang", "langmatches", "datatype", "bound", "sameterm", "isiri", "isuri",
                        "isblank", "isliteral", "union", "a"]);
  var keywords = wordRegexp([
  	('ACCESSIBLE'),('COUNT'),('NULL'), ('DBSC'), ('True'), ('False'), ('DBSC_DATA'), ('DBSC_DATA'), ('DBSC_ACTIVITYLIST'), ('DBSC_ACTIVITY'), 
  	('DBSC_NBLINE'), ('DBSC_IMPACT'), ('DBSC_WEBSITE'), ('DBSC_USER'), ('DBSC_LANG'),
  	('ACTIVITY.START'),('ACTIVITY.STARTW'),('ACTIVITY.STARTW2'),('ACTIVITY.WAIT'),('AGREG.AVG'),('AGREG.COUNT'),('AGREG.FIRST'),('AGREG.LAST'),('AGREG.MAX'),('AGREG.MAXSTR'),
('AGREG.MIN'),('AGREG.MINSTR'),('AGREG.SUM'),('ATOME.DISTINCTATOME'),('ATOME.DISTINCTLRTRIMATOME'),('ATOME.FINDATOME'),('ATOME.GETATOME'),('ATOME.GETATOMESIZE'),
('ATOME.GETFIRSTATOME'),('ATOME.GETLASTATOME'),('ATOME.INTCONDOR'),('ATOME.STRCONDOR'),('BLOG.DELIMAGE'),('BLOG.GETIMAGE'),('BOOL.AND'),('BOOL.ENDSWITH'),
('BOOL.EQUAL'),('BOOL.GREATER'),('BOOL.GREATERE'),('BOOL.ISBOOL'),('BOOL.ISCHAR'),('BOOL.ISDATE'),('BOOL.ISDECIMAL'),('BOOL.ISENUM'),('BOOL.ISHOUR'),
('BOOL.ISINTEGER'),('BOOL.ISNULL'),('BOOL.ISNUMBER'),('BOOL.ISTIMESTAMP'),('BOOL.ISVARCHAR'),('BOOL.LESS'),('BOOL.LESSE'),('BOOL.LIKE'),('BOOL.NOT'),
('BOOL.NUMEQUAL'),('BOOL.OR'),('BOOL.STARTSWITH'),('DATABASE.DBSCSELECT'),('DATABASE.DBSCSELECT2'),('DATABASE.DBSCSELECT3'),('DATABASE.EXESELECT'),
('DATABASE.EXESQL'),('DATABASE.LASTLOGIN'),('DATABASE.MASKSQL'),('DATABASE.PINGDB'),('DATABASE.STARTH2Server'),('DATABASE.STARTH2Server2'),
('DATABASE.STOPH2Server'),('DATABASE.STOPH2Server2'),('DATE.DATEFR'),('DATE.DATEHOUR'),('DATE.SYSDATE'),('DATE.SYSDATER'),('DATE.SYSTIMESTAMP'),
('DATE.SYSTIMESTAMPR'),('ABS'),('ADD'),('AND'),('AVG'),('BACKUP'),('CEIL'),('CERTGRANTLIST'),('CHANGECRON'),('CHR'),('CLSPARAM'),('CONCAT'),
('COUNT'),('DATA2HTML'),('DATEFR'),('DBSCSELECT'),('DBSCSELECT2'),('DELETEBACKUP'),('DELVAR'),('DEPLOY'),('DEPLOYCLASS'),('DEPLOYCONNECTION'),
('DEPLOYSITE'),('DEPLOYSQL'),('DEPLOYUSER'),('DEPLOYWEBSITE'),('DIV'),('ENDSWITH'),('EQUAL'),('EXE'),('EXECMD'),('EXESELECT'),('EXESQL'),
('EXISTDATA'),('EXISTPARAM'),('FIRST'),('FLOOR'),('FOR'),('GC'),('GENERATECERT'),('GETACTIVITY'),('GETATOME'),('GETATOMESIZE'),('GETCLASS'),
('GETCONNECTION'),('GETFIRSTATOME'),('GETLASTATOME'),('GETPARAM'),('GETPARAMSIZE'),('GETSERVER'),('GETSITE'),('GETUSER'),('GETVAR'),
('GETVARSIZE'),('GETWEBSITE'),('GETWPARAM'),('GREATER'),('GREATERE'),('HEXREAD'),('HEXWRITE'),('HTML2DATA'),('IF'),('INSTR'),('ISBOOL'),
('ISCHAR'),('ISDATE'),('ISDECIMAL'),('ISENUM'),('ISHOUR'),('ISINTEGER'),('ISNULL'),('ISNUMBER'),('ISTIMESTAMP'),('ISVARCHAR'),('ITRIM'),
('LANGID'),('LAST'),('LASTLOGIN'),('LENGTH'),('LESS'),('LESSE'),('LIKE'),('LIKESPECIAL'),('LIKESPECIAL2'),('LOADBALANCERSESSION'),
('LOCALIP'),('LOCALMAC'),('LOWER'),('LPAD'),('LRTRIM'),('LTRIM'),('MAIL'),('MAILADD'),('MAX'),('MAXSTR'),('MIN'),('MINSTR'),('MUL'),('NOT'),
('NUMEQUAL'),('OR'),('PING'),('PINGDB'),('PINGPORT'),('PINGURL'),('POWER'),('REPEAT'),('REPLACE'),('ROUND'),('RPAD'),('RTRIM'),('SCHEDULER'),
('SETPARAM'),('SETVAR'),('SIGN'),('SQRT'),('START'),('STARTCRON'),('STARTSWITH'),('STOPCLUSTER'),('STOPCRON'),('SUB'),('SUBLRCHAR'),('SUBSTR'),
('SUM'),('SYSDATE'),('SYSDATER'),('SYSTIMESTAMP'),('SYSTIMESTAMPR'),('TRACE'),('TRIM'),('TXT'),('TXT2'),('UPPER'),('WAIT'),('WHILE'),
('DEPLOY.CHANGECRON'),('DEPLOY.DEPLOY'),('DEPLOY.DEPLOYCLASS'),('DEPLOY.DEPLOYCLASSM'),('DEPLOY.DEPLOYCONNECTION'),('DEPLOY.DEPLOYSITE'),('DEPLOY.DEPLOYSQL'),
('DEPLOY.DEPLOYUSER'),('DEPLOY.DEPLOYWEBSITE'),('DEPLOY.STARTCRON'),('DEPLOY.STOPCRON'),('FILE.COPY'),('FILE.DELETE'),('FILE.GETFILE'),('FILE.GETINIVALUE'),
('FILE.HEXREAD'),('FILE.HEXWRITE'),('HTML.AEIOU'),('HTML.AUTOSIZE'),('HTML.CALENDAR'),('HTML.COLSIZE'),('HTML.DECODE'),('HTML.ENCODE'),('HTML.ISTODAY'),
('HTML.ISVALID'),('HTML.ISVALIDSite'),('HTML.LINK'),('HTML.STATELIGHT'),('HTML.STATELIGHT2'),('HTML.STATELIGHT2Site'),('HTML.STATEPBAR'),('HTML.STATEPBARSite'),
('HTML.STATEPBARV'),('HTML.STATEPBARVSite'),('INTERNET.LANGID'),('INTERNET.PINGURL'),('INTERNET.TXTLANGX'),('JFREECHART.ALPHA3DPIE'),('JFREECHART.DIAL1'),
('JFREECHART.DIAL2'),('JFREECHART.EXPLODEPIE'),('JFREECHART.EXPLODERING'),('JFREECHART.HORIZONTAL3DBAR'),('JFREECHART.HORIZONTALBAR'),
('JFREECHART.HORIZONTALSERIE3DBAR'),('JFREECHART.HORIZONTALSERIEAREA'),('JFREECHART.HORIZONTALSERIEBAR'),('JFREECHART.HORIZONTALSERIELAYERED'),
('JFREECHART.HORIZONTALSERIELINE3D'),('JFREECHART.HORIZONTALSERIELINESHAPE'),('JFREECHART.HORIZONTALXYBARDAY'),('JFREECHART.HORIZONTALXYBARHOUR'),
('JFREECHART.HORIZONTALXYBARINT'),('JFREECHART.HORIZONTALXYBARMONTH'),('JFREECHART.HORIZONTALXYBARYEAR'),('JFREECHART.HORIZONTALXYSTEPINT'),
('JFREECHART.METER1'),('JFREECHART.METER2'),('JFREECHART.METER3'),('JFREECHART.SIMPLE3DPIE'),('JFREECHART.SIMPLEPIE'),('JFREECHART.SIMPLERING'),
('JFREECHART.VERTICAL3DBAR'),('JFREECHART.VERTICALBAR'),('JFREECHART.VERTICALSERIE3DBAR'),('JFREECHART.VERTICALSERIEAREA'),
('JFREECHART.VERTICALSERIEBAR'),('JFREECHART.VERTICALSERIELAYERED'),('JFREECHART.VERTICALSERIELINE3D'),('JFREECHART.VERTICALSERIELINESHAPE'),
('JFREECHART.VERTICALXYBARDAY'),('JFREECHART.VERTICALXYBARDAY2'),('JFREECHART.VERTICALXYBARHOUR'),('JFREECHART.VERTICALXYBARHOUR2'),
('JFREECHART.VERTICALXYBARINT'),('JFREECHART.VERTICALXYBARMONTH'),('JFREECHART.VERTICALXYBARMONTH2'),('JFREECHART.VERTICALXYBARYEAR'),
('JFREECHART.VERTICALXYLINESHAPECATMONTH'),('JFREECHART.VERTICALXYLINESHAPEDAY'),('JFREECHART.VERTICALXYLINESHAPEDAY2'),('JFREECHART.VERTICALXYLINESHAPEHOUR2'),
('JFREECHART.VERTICALXYSPLINEINT'),('JFREECHART.VERTICALXYSTEPINT'),('LOG.TRACE'),('MAIL.MAIL'),('MAIL.MAILADD'),('MATH.ABS'),('MATH.ADD'),
('MATH.CEIL'),('MATH.DIV'),('MATH.FLOOR'),('MATH.MUL'),('MATH.POWER'),('MATH.RANDOM'),('MATH.ROUND'),('MATH.SIGN'),('MATH.SQRT'),('MATH.SUB'),
('NETWORK.LOCALIP'),('NETWORK.LOCALMAC'),('NETWORK.PING'),('NETWORK.PINGPORT'),('PARAM.CLSCLUSTERPARAM'),('PARAM.CLSPARAM'),('PARAM.EXISTPARAM'),
('PARAM.GETPARAM'),('PARAM.GETPARAMSIZE'),('PARAM.GETSOFTWAREPARAM'),('PARAM.GETWPARAM'),('PARAM.GETWPARAM1'),('PARAM.SETPARAM'),('PRGM.EXE'),
('PRGM.FOR'),('PRGM.IF'),('PRGM.REPEAT'),('PRGM.WHILE'),('SERVER.GENERATEDOC'),('SERVER.GETACTIVITY'),('SERVER.GETBACKUP'),('SERVER.GETBANK'),
('SERVER.GETCLASS'),('SERVER.GETCLASSLOADER'),('SERVER.GETCONNECTION'),('SERVER.GETNBBACKUP'),('SERVER.GETNBERRBACKUP'),('SERVER.GETNBSITE'),
('SERVER.GETNBSITEVISITED'),('SERVER.GETSERVER'),('SERVER.GETSITE'),('SERVER.GETSITEVISITED'),('SERVER.GETTHEME'),('SERVER.GETUSER'),
('SERVER.GETWEBSITE'),('SERVER.INITTHEMEPICTURE'),('SERVER.UNZIPTHEME'),('SERVER.UPDSOURCE'),('SERVER.UPDSOURCETEST'),('SERVER.ZIPTHEME'),('STRING.CHR'),
('STRING.CONCAT'),('STRING.INSTR'),('STRING.ITRIM'),('STRING.LENGTH'),('STRING.LIKESPECIAL'),('STRING.LIKESPECIAL2'),('STRING.LOWER'),('STRING.LPAD'),
('STRING.LRTRIM'),('STRING.LTRIM'),('STRING.REPLACE'),('STRING.RPAD'),('STRING.RTRIM'),('STRING.SUBLRCHAR'),('STRING.SUBSTR'),('STRING.TRIM'),
('STRING.TXT'),('STRING.TXT2'),('STRING.UPPER'),('STRING.VERSION'),('STRING.ZERO'),('SYSTEM.BACKUP'),('SYSTEM.CHSTATEPOOL'),('SYSTEM.CLUSTERACTIVITY'),
('SYSTEM.DELETEBACKUP'),('SYSTEM.DELETETMP'),('SYSTEM.DISK'),('SYSTEM.EXECMD'),('SYSTEM.EXPIRATION'),('SYSTEM.FREENODEID'),('SYSTEM.GC'),
('SYSTEM.GETSERIALX509'),('SYSTEM.HOSTNAME'),('SYSTEM.NODEID'),('SYSTEM.OSARCHI'),('SYSTEM.OSNAME'),('SYSTEM.PRAMALL'),('SYSTEM.PRAMLANG'),('SYSTEM.PRAMSYSTEM'),
('SYSTEM.PRAMVERSION'),('VAR.DELVAR'),('VAR.EXISTVAR'),('VAR.GETVAR'),('VAR.GETVARSIZE'),('VAR.SETVAR'),('XML.DATA2HTML'),('XML.EXISTDATA'),('XML.HTML2DATA')
  ]);
  var operatorChars = /[*+\-<>=&|]/;

  function tokenBase(stream, state) {
    var ch = stream.next();
    curPunc = null;
    if (ch == "$" || ch == "?") {
      stream.match(/^[\w\d]*/);
      return "variable-2";
    }
    else if (ch == "<" && !stream.match(/^[\s\u00a0=]/, false)) {
      stream.match(/^[^\s\u00a0>]*>?/);
      return "atom";
    }
    else if (ch == "\"" || ch == "'") {
      state.tokenize = tokenLiteral(ch);
      return state.tokenize(stream, state);
    }
    else if (ch == "`") {
      state.tokenize = tokenOpLiteral(ch);
      return state.tokenize(stream, state);
    }
    else if (/[{}\(\),\.;\[\]]/.test(ch)) {
      curPunc = ch;
      return null;
    }
    else if (ch == "-") {
		ch2 = stream.next();
		if(ch2=="-")
		{
			stream.skipToEnd();
			return "comment";
		}

    }
    else if (operatorChars.test(ch)) {
      stream.eatWhile(operatorChars);
      return null;
    }
    else if (ch == ":") {
      stream.eatWhile(/[\w\d\._\-]/);
      return "atom";
    }
    else {
      stream.eatWhile(/[_\w\d]/);
      if (stream.eat(":")) {
        stream.eatWhile(/[\w\d_\-]/);
        return "atom";
      }
      var word = stream.current(), type;
      if (ops.test(word))
        return null;
      else if (keywords.test(word))
        return "keyword";
      else
        return "variable";
    }
  }

  function tokenLiteral(quote) {
    return function(stream, state) {
      var escaped = false, ch;
      while ((ch = stream.next()) != null) {
        if (ch == quote && !escaped) {
          state.tokenize = tokenBase;
          break;
        }
        escaped = !escaped && ch == "\\";
      }
      return "string";
    };
  }

  function tokenOpLiteral(quote) {
    return function(stream, state) {
      var escaped = false, ch;
      while ((ch = stream.next()) != null) {
        if (ch == quote && !escaped) {
          state.tokenize = tokenBase;
          break;
        }
        escaped = !escaped && ch == "\\";
      }
      return "variable-2";
    };
  }


  function pushContext(state, type, col) {
    state.context = {prev: state.context, indent: state.indent, col: col, type: type};
  }
  function popContext(state) {
    state.indent = state.context.indent;
    state.context = state.context.prev;
  }

  return {
    startState: function(base) {
      return {tokenize: tokenBase,
              context: null,
              indent: 0,
              col: 0};
    },

    token: function(stream, state) {
      if (stream.sol()) {
        if (state.context && state.context.align == null) state.context.align = false;
        state.indent = stream.indentation();
      }
      if (stream.eatSpace()) return null;
      var style = state.tokenize(stream, state);

      if (style != "comment" && state.context && state.context.align == null && state.context.type != "pattern") {
        state.context.align = true;
      }

      if (curPunc == "(") pushContext(state, ")", stream.column());
      else if (curPunc == "[") pushContext(state, "]", stream.column());
      else if (curPunc == "{") pushContext(state, "}", stream.column());
      else if (/[\]\}\)]/.test(curPunc)) {
        while (state.context && state.context.type == "pattern") popContext(state);
        if (state.context && curPunc == state.context.type) popContext(state);
      }
      else if (curPunc == "." && state.context && state.context.type == "pattern") popContext(state);
      else if (/atom|string|variable/.test(style) && state.context) {
        if (/[\}\]]/.test(state.context.type))
          pushContext(state, "pattern", stream.column());
        else if (state.context.type == "pattern" && !state.context.align) {
          state.context.align = true;
          state.context.col = stream.column();
        }
      }

      return style;
    },

    indent: function(state, textAfter) {
      var firstChar = textAfter && textAfter.charAt(0);
      var context = state.context;
      if (/[\]\}]/.test(firstChar))
        while (context && context.type == "pattern") context = context.prev;

      var closing = context && firstChar == context.type;
      if (!context)
        return 0;
      else if (context.type == "pattern")
        return context.col;
      else if (context.align)
        return context.col + (closing ? 0 : 1);
      else
        return context.indent + (closing ? 0 : indentUnit);
    }
  };
});

CodeMirror.defineMIME("text/x-dbsc", "dbsc");
